
;Offizielle XPath 1.0 Referenz: http://www.w3.org/TR/xpath/

Type XPath_step
	Field context.DOM_Node
	Field selector$
	Field predicate$
	Field pred.XPath_predNode
	Field nextstep.XPath_step
End Type

Type XPath_predNode
	Field value$
	Field a.XPath_predNode
	Field b.XPath_predNode
	Field parent.XPath_predNode
End Type

Const XPath_STATE_INIT=0
Const XPath_STATE_SLASH=1
Const XPath_STATE_IN_PRED=2
Const XPath_STATE_IN_STRING=3
Const XPath_STATE_SELECTOR=4
Const XPath_STATE_DOT=5

Global XPath_state=XPath_STATE_INIT
Global XPath_char$=""
Global XPath_temp$=""
Global XPath_currentNode.XPath_step

Dim XPath_SplitSigns$(9)
.PredSplitSigns
Data " ","=","!=","<","<=",">",">=","*","+","-"
;"div" -> Division
Restore PredSplitSigns
For i=0 To 9
	Read XPath_SplitSigns$(i)
Next
	
Function XPath_parseString(txt$, context.DOM_Node, result=0, resultsize=0, recursive=True)
	txt$=CutSpaces(txt$)
	If result=0 Then
		result=CreateBank(4096)
	EndIf
	If context=Null Then
		ResizeBank(result,0)
		Return result
	EndIf
	
	XPath_state=XPath_STATE_INIT
	XPath_currentNode=New XPath_step ;root
	XPath_currentNode\context=context
	Local root.XPath_step=XPath_currentNode
	
	For i=1 To Len(txt$)
		XPath_char$=Mid(txt$,i,1)
		Select XPath_char$
			Case "/"
				If XPath_state=XPath_STATE_DOT Then
					;Drop this, because its the same as currentNode
					
				Else If XPath_state=XPath_STATE_INIT Then
					;absoluter Pfad
					;DEBUG - woher richtige DOM-Root nehmen? Also bezogen auf was? Nicht ohnehin context?
					;XPath_currentNode\context=DOM_root
				Else If XPath_state=XPath_STATE_SLASH Then
					;//
					DebugLog_XPathParse "Found Selector: "+"//"
					XPath_currentNode\selector$="//"
					
					XPath_NewStep()
				Else If XPath_state=XPath_STATE_SELECTOR Then
					DebugLog_XPathParse "Found Selector: "+XPath_temp$
					XPath_currentNode\selector$=CutSpaces(XPath_temp$)
					
					XPath_NewStep()
				EndIf
				XPath_state=XPath_STATE_SLASH
				XPath_temp$=""
			Case "["
				If XPath_state=XPath_STATE_SELECTOR Then
					DebugLog_XPathParse "Found Selector: "+XPath_temp$
					XPath_currentNode\selector$=CutSpaces(XPath_temp$)
					XPath_temp$=""
				EndIf
				XPath_state=XPath_STATE_IN_PRED
			Case "]"
				If XPath_state=XPath_STATE_IN_PRED Then
					DebugLog_XPathParse "Found Predicate: "+XPath_temp$
					XPath_currentNode\predicate$=CutSpaces(XPath_temp$)
					XPath_temp$=""
					
					XPath_NewStep()
				EndIf
				
			Case "|"
				;Last Selector of previous statement
				DebugLog_XPathParse "Found Selector: "+XPath_temp$
				XPath_currentNode\selector$=CutSpaces(XPath_temp$)
				XPath_temp$=""
				
				;Merge Queries
				result=XPath_parseString(Mid(txt$,i+1), context, result, resultsize)
				resultsize=BankSize(result)/4
				ResizeBank(result,4096)
				
				;Stop Processing the previous one
				;Attention: By calling the other XPath_parseString(..) above, we cannot use the globals any longer (XPath_temp$!)
				Exit
				
			Case ":"
				;DEBUG - Axis?
				
			Case "."
				If XPath_state=XPath_STATE_DOT Then
					XPath_temp$=".."
					XPath_state=XPath_STATE_SELECTOR
				Else
					XPath_state=XPath_STATE_DOT
					XPath_anyChar()
				EndIf
				
;			Case "'"
;				XPath_quote()
;			Case Chr(34)
;				XPath_quote()
				
;			Case " "
;				If XPath_state=XPath_STATE_IN_STRING Then
;					XPath_anyChar()
;				Else
;					;Ommit Whitespace
;				EndIf
				
			Default
				;* und @ will be processed later
				XPath_anyChar()
				If XPath_state<>XPath_STATE_IN_PRED And XPath_state<>XPath_STATE_IN_STRING Then
					XPath_state=XPath_STATE_SELECTOR
				EndIf
		End Select
	Next
	
	If XPath_temp$="" Then
		Delete XPath_currentNode
	Else
		DebugLog_XPathParse "Found Selector: "+XPath_temp$
		XPath_currentNode\selector$=CutSpaces(XPath_temp$)
		XPath_temp$=""
	EndIf
	
	For XStep.XPath_step=Each XPath_step
		If XStep\predicate$<>"" And XStep\pred=Null Then
			XStep\pred=XPath_parsePredicate(XStep\predicate$)
		EndIf
	Next
	
	resultsize=XPath_evaluate(root, result, resultsize)
	
	ResizeBank(result,resultsize*4)
	
	If recursive Or DEBUG_XPATH_EVAL Then
		DebugLog_XPathResult "XPath-Results of "+txt$+": ("+resultsize+")"
		For i=0 To resultsize-1
			n.DOM_Node=Object.DOM_Node(PeekInt(result,i*4))
			DebugLog_XPathResult "  Name: "+n\name$
			DebugLog_XPathResult "  Val:  "+n\value$
		Next
		
		Delete Each XPath_step
		Delete Each XPath_predNode
	EndIf
	
	Return result
End Function

Function XPath_parsePredicate.XPath_predNode(txt$)
	If txt$="" Then Return Null
	
	Local char$=""
	Local lastchar$=""
	Local temp$=""
	Local node.XPath_predNode
	Local quote$=""
	
	Local startnode.XPath_predNode=New XPath_predNode
	
	For i=1 To Len(txt$)
		lastchar$=char$
		char$=Mid(txt$,i,1)
		append=True
		If char$="'" Or char$=Chr(34) Then
			If quote$="" Then
				quote$=char$
			Else If char$=quote$ Then
				quote$=""
			EndIf
		EndIf
		If quote$="" Then
			For j=0 To 9
				If char$=XPath_SplitSigns$(j) Then
					If temp$<>"" Then
						node=New XPath_predNode
						node\value$=temp$
						temp$=""
						If char$<>" " Then
							node=New XPath_predNode
							node\value$=char$
						EndIf
						DebugLog_XPathParse "XPath Pred Special Char: "+char$
						append=False
						Exit
					EndIf
				Else If lastchar$+char$=XPath_SplitSigns$(j) Then
					node=New XPath_predNode
					node\value$=Left(temp$,Len(temp$)-1)
					temp$=""
					node=New XPath_predNode
					node\value$=lastchar$+char$
					DebugLog_XPathParse "XPath Pred Special Char: "+lastchar$+char$
					append=False
					Exit
				EndIf
			Next
		EndIf
		If append Then
			temp$=temp$+char$
		EndIf
	Next
	node=New XPath_predNode
	node\value$=temp$
	
	DebugLog_XPathParse "XPath Parse Pred: "+txt$
	node=startnode
	While node<>Null
		If node\value$=Int(node\value$) Then
			;Sonderfall fr Numerische Angaben
			n.XPath_predNode=New XPath_predNode
			n\value$="position()"
			Insert n Before node
			n=New XPath_predNode
			n\value$="="
			Insert n Before node
			n=New XPath_predNode
			n\value$=node\value$
			Insert n Before node
			node=After node
			If node=Null Then
				Delete Last XPath_predNode
				Exit
			EndIf
			Delete Before node
		Else
			node=After node
		EndIf
	Wend
	
;	node=startnode
;	While node<>Null
;		DebugLog "  "+node\value$
;		node=After node
;	Wend
	
	XPath_CombinePredNodes(startnode,"and")
	XPath_CombinePredNodes(startnode,"or")
	For i=1 To 9
		XPath_CombinePredNodes(startnode,XPath_SplitSigns(i))
	Next
	
	node=After startnode
	While node<>Null
		If node\parent=Null Then
			DebugLog_XPathParse "   Root: "+node\value$
			startnode=node
			Exit
		EndIf
		node=After node
	Wend
	
	Return startnode
End Function

Function XPath_evaluate(XStep.XPath_step, result, resultsize)
	If XStep=Null Then Return
	
	Local temp$
	Local childsteps.XPath_step[1024] ;Wenn wir mit der Dimensionierung nicht mehr auskommen helfen nur noch Banks mit Handles
									;KEINE globalen Arrays wegen rekursion!
	Local childsteps_count=0
	
	DebugLog_XPathEval "Apply "+XStep\selector$+"["+XStep\predicate$+"]"+" to " ;XStep\context\name$
	DebugLog_XPathEval "              "+DebugNode(XStep\context, "",False,True,0,True)
	If Left(XStep\selector$,1)="@" Then
		temp$=Mid(XStep\selector$,2)
		For i=0 To XStep\context\attr_count-1
			If XStep\context\attr[i]\name$=temp$ Then
				DebugLog_XPathEval "Eval Attr "+XStep\context\attr[i]\name$
				newstep.XPath_step=XPath_DuplicateStep(XStep\nextstep, XStep\context\attr[i])
				If newstep<>Null Then
					childsteps[childsteps_count]=newstep
					childsteps_count=childsteps_count+1
				Else
					resultsize=XPath_evalNode(XStep.XPath_step, XStep\context\attr[i], result, resultsize)
				EndIf
			EndIf
		Next
	Else
		temp$=Lower(XStep\selector$)
		If Instr(temp$,"(")>0 Then
			;Pfusch fr text() weil das nextchilds erzeugt
			If temp$="text()" Then
				For i=0 To XStep\context\childs_count-1
					If XStep\context\childs[i]\typ=DOM_TYPE_TEXT Then
						newstep.XPath_step=XPath_DuplicateStep(XStep\nextstep, XStep\context\childs[i])
						If newstep<>Null Then
							childsteps[childsteps_count]=newstep
							childsteps_count=childsteps_count+1
						Else
							resultsize=XPath_evalNode(XStep.XPath_step, XStep\context\childs[i], result, resultsize)
						EndIf
					EndIf
				Next
			Else
				resultsize=XPath_evaluateFunc(XStep, result, resultsize)
			EndIf
			
		Else If temp$=".." Then
			DebugLog_XPathEval "Eval Node "+XStep\context\parent\name$
			newstep.XPath_step=XPath_DuplicateStep(XStep\nextstep, XStep\context\parent)
			If newstep<>Null Then
				childsteps[childsteps_count]=newstep
				childsteps_count=childsteps_count+1
			Else
				resultsize=XPath_evalNode(XStep.XPath_step, XStep\context\parent, result, resultsize)
			EndIf
		Else
			For i=0 To XStep\context\childs_count-1
				If XStep\context\childs[i]\name$=temp$ Or temp$="*" Or temp$="//" Then
					DebugLog_XPathEval "Eval Node "+XStep\context\childs[i]\name$
					If temp$="//" Then
						newstep.XPath_step=XPath_DuplicateStep(XStep, XStep\context\childs[i])
						resultsize=XPath_evaluate(newstep, result, resultsize)
					EndIf
					newstep.XPath_step=XPath_DuplicateStep(XStep\nextstep, XStep\context\childs[i])
					If newstep<>Null Then
						childsteps[childsteps_count]=newstep
						childsteps_count=childsteps_count+1
					Else
						resultsize=XPath_evalNode(XStep.XPath_step, XStep\context\childs[i], result, resultsize)
					EndIf
				EndIf
			Next
		EndIf
	EndIf
	
	For i=0 To childsteps_count-1
		If XPath_evaluatePredicate(XStep\pred, childsteps[i]\context) Then
			resultsize=XPath_evaluate(childsteps[i], result, resultsize)
		EndIf
	Next
	
	Return resultsize
End Function

Function XPath_evaluateFunc(XStep.XPath_step, result, resultsize)
	Local n.DOM_Node
	Local temp$=Lower(XStep\selector$)
	Select temp$
		;Not the best way to evaluate functions!!!!
		Case "position()"
			n=New DOM_Node
			n\typ=DOM_TYPE_TEXT
			
			Local count=0
			Local n2.DOM_Node=XStep\context\parent
			For i=0 To n2\childs_count-1
				If n2\childs[i]\name$=XStep\context\name Then
					count=count+1
					If n2\childs[i]=XStep\context Then
						n\value$=count
						Exit
					EndIf
				EndIf
			Next
			
			PokeInt(result,resultsize*4,Handle(n))
			resultsize=resultsize+1
			
		Case "true()"
			n=New DOM_Node
			n\typ=DOM_TYPE_TEXT
			n\value$=1
			PokeInt(result,resultsize*4,Handle(n))
			resultsize=resultsize+1
			
		Case "false()"
			n=New DOM_Node
			n\typ=DOM_TYPE_TEXT
			n\value$=0
			PokeInt(result,resultsize*4,Handle(n))
			resultsize=resultsize+1
			
		Case "last()"
			n=New DOM_Node
			n\typ=DOM_TYPE_TEXT
			n\value$=XStep\context\parent\childs_count
			PokeInt(result,resultsize*4,Handle(n))
			resultsize=resultsize+1
			
		Default
			DebugLog "XPath Notice: Unknown function-name: "+temp$
			
	End Select
	
	Return resultsize
End Function

Function XPath_evaluatePredicate$(pred.XPath_predNode, context.DOM_Node)
	If pred=Null Then Return True
	
	If pred\a=Null And pred\b<>Null Then
		DebugLog "XPath Notice: Syntax Error in Query?"
	EndIf
	If pred\a<>Null And pred\b=Null Then
		DebugLog "XPath Notice: Syntax Error in Query?"
	EndIf
	
	Local a$=XPath_evaluatePredicate(pred\a, context)
	Local b$=XPath_evaluatePredicate(pred\b, context)
	Local ret$=""
	Select pred\value$
		Case "and"
			If Int(a)<>a Then
				;String! It does exist, although it does not evaluate to 1!
				a=True
			EndIf
			If Int(b)<>b Then
				b=True
			EndIf
			ret$=Int(a)>0 And Int(b)>0
		Case "or"
			If Int(a)<>a Then
				a=True
			EndIf
			If Int(b)<>b Then
				b=True
			EndIf
			ret$=Int(a)>0 Or Int(b)>0
		Case "="
			ret$=(Lower(a) = Lower(b))
		Case "<"
			ret$=(Lower(a) < Lower(b))
		Case "<="
			ret$=(Lower(a) <= Lower(b))
		Case ">"
			ret$=(Lower(a) > Lower(b))
		Case ">="
			ret$=(Lower(a) >= Lower(b))
		Case "+"
			ret$=Int(a) + Int(b)
		Case "-"
			ret$=Int(a) - Int(b)
		Case "*"
			ret$=Int(a) * Int(b)
		Default
			If Int(pred\value$)=pred\value$ Then
				;Number
				ret$=pred\value$
			Else If Left(pred\value$,1)="'" Or Left(pred\value$,1)=Chr(34) Then
				;String
				ret$=Mid(Left(pred\value$,Len(pred\value$)-1),2)
			Else
				;Another XPath with root=context!
				result=XPath_parseString(pred\value$, context, 0, 0, False)
				For i=0 To BankSize(result)-1 Step 4
					n.DOM_Node=Object.DOM_Node(PeekInt(result,i))
					ret$=n\value$
					Exit
					;Only the First Result will be evaluated
				Next
			EndIf
	End Select
	
	DebugLog_XPathEval "evalPred "+pred\value$+" on "+context\name$+" = "+ret$
	
	Return ret$
End Function

;Helper

Function XPath_anyChar()
	XPath_temp$=XPath_temp$+XPath_char$
End Function

Function XPath_NewStep()
	Local prev.XPath_step=XPath_currentNode
	XPath_currentNode=New XPath_step
	prev\nextstep=XPath_currentNode
End Function

Function XPath_DuplicateStep.XPath_step(XStep.XPath_step, context.DOM_Node)
	If XStep=Null Then Return Null
	Local s.XPath_step=New XPath_step
	s\selector$=XStep\selector$
	s\predicate$=XStep\predicate$
	s\pred=XStep\pred
	s\nextstep=XStep\nextstep
	s\context=context
	Return s
End Function

Function XPath_CombinePredNodes(start.XPath_predNode, sign$)
	Local node.XPath_predNode=start
	While node<>Null
		If node\value$=sign$ Then
			node\a=Before node
			node\b=After node
			
			If node\a\parent<>Null Then
				node\a\parent\b=node
				node\parent=node\a\parent
			EndIf
			node\a\parent=node
			
			If node\b\parent<>Null Then
				node\b\parent\a=node
				node\parent=node\b\parent
			EndIf
			node\b\parent=node
		EndIf
		node=After node
	Wend
End Function

Function XPath_evalNode(XStep.XPath_step, node.DOM_Node, result, resultsize)
	DebugLog_XPathEval "             eval node "+node\name$+", pred "+XStep\predicate$
	If XPath_evaluatePredicate(XStep\pred, node) Then
		PokeInt(result,resultsize*4,Handle(node))
		resultsize=resultsize+1
	EndIf
	Return resultsize
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D